#!/bin/sh

# Script to build the VSW4 test suite
# Should be run from the root of unpacked tarball

export TET_ROOT=`pwd`
export PATH=$TET_ROOT/tet/bin:$TET_ROOT/xtest/bin:$PATH

# Configure tetbuild.cfg and tetclean.cfg
case `uname -m` in
x86_64|ppc64|s390x)
  sed -e "s\\^TET_ROOT=\\TET_ROOT=$TET_ROOT\\" \
      -e "s\\/usr/X11R6/lib\\/usr/X11R6/lib64\\" \
  xtest/tetbuild.cfg.skel > xtest/tetbuild.cfg
  ;;
*)
  sed -e "s\\^TET_ROOT=\\TET_ROOT=$TET_ROOT\\" \
  xtest/tetbuild.cfg.skel > xtest/tetbuild.cfg
  ;;
esac

# Compile harness
make install

if [ $? -ne 0 ]; then
    echo Build of harness failed
    exit 1
fi

# Build testcases
cd $TET_ROOT/xtest

# Recreate the .Xdefaults and .Xdefaults-hostname
rm -f tset/CH10/gtdflt/.Xdefaults

tcc -b -p
grep '|FAIL' `expr \`ls -d results/0* | tail -n 1\``/journal

if [ $? -ne 1 ]; then
  echo Build of testcases failed
  exit 1
fi

echo
echo
echo Build of testcases completed
echo 
echo Run the testcases by executing run_vsw4.sh
echo

