/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: dssvundrs.m,v 1.7 92/06/11 15:59:25 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   Bool
 *   XDoesSaveUnders(screen)
 *   Screen	*screen;
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XDoesSaveUnders	1
char    *TestName = "XDoesSaveUnders";

/*
 * Defines for different argument types
 */


/*
 * Arguments to the XDoesSaveUnders function
 */
static Screen	*screen;


static char	*ts = "True";
static char	*fs = "False";
static char	es[9];

static char *
tfs(tf)
int	tf;
{
	switch(tf) {
	case True:
		return ts;
	case False:
		return fs;
	default:
		sprintf(es, "%d", tf);
		return es;
	}
}

int 	tet_thistest;

/*
 * Called at the beginning of each test purpose to reset the
 * arguments to their initial values
 */
static void
setargs()
{
	screen = DefaultScreenOfDisplay(Dsp);
}

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XDoesSaveUnders-1.(C)
 * If the screen screen supports save unders: A call to
 * XDoesSaveUnders returns True. Otherwise: A call to
 * XDoesSaveUnders returns False.
 */
static void
t001()
{
Bool dsu;
int 	pass = 0, fail = 0;

	tpstartup();
	setargs();

	startcall(Dsp);
	if (isdeleted())
		return;
	dsu = XDoesSaveUnders(screen);
	endcall(Dsp);
	if (geterr() != Success) {
		report("Got %s, Expecting Success", errorname(geterr()));
		FAIL;
	}
	if(config.does_save_unders == 1)
		if(dsu != True) {
			report("%s() returned %s instead of True (%d).", TestName, tfs(dsu), True);
			FAIL;
		} else
			CHECK;
	else
		if(dsu != False) {
			report("%s() returned %s instead of False (%d).", TestName, tfs(dsu), False);
			FAIL;
		} else
			CHECK;

	CHECKPASS(1);
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
