/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: nop.m,v 1.6 92/06/11 16:00:41 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   
 *   XNoOp(display)
 *   Display	*display;
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XNoOp	1
char    *TestName = "XNoOp";

/*
 * Defines for different argument types
 */
#define A_DISPLAY display


/*
 * Arguments to the XNoOp function
 */
static Display	*display;


int 	tet_thistest;

/*
 * Called at the beginning of each test purpose to reset the
 * arguments to their initial values
 */
static void
setargs()
{
	display = Dsp;
}

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XNoOp-1.(A)
 * A call to XNoOp sends a NoOperation protocol request to the
 * server.
 */
static void
t001()
{
int	nr, lr;
int 	pass = 0, fail = 0;

	tpstartup();
	setargs();

	lr = XNextRequest(display);
	_startcall(display);
	XNoOp(display);
	_endcall(display);

	if( geterr() != Success) {
		report("Got %s, Expecting Success", errorname(geterr()));
                FAIL;
        } else
		CHECK;

	nr = XNextRequest(display);

	if(nr == lr) {
		report("%s() did not cause the next serial number to change.", TestName);
		FAIL;
	} else
		CHECK;

	CHECKUNTESTED(2);
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
