/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: srvrvndr.m,v 1.5 92/06/11 16:02:32 rws Exp $
 */
>>SET   macro
>>TITLE XServerVendor CH02
char *
XServerVendor(display)
Display	*display = Dsp;
>>EXTERN
#include <string.h>
#define SEPS	":"
>>ASSERTION Good A
A call to xname returns a pointer to a null-terminated string that
identifies the owner of the X server implementation.
>>STRATEGY
Obtain the server vendor string using xname.
Verify that the value is that given in parameter XT_SERVER_VENDOR.
>>CODE
char	*sv;
char	*tok;
char	*Pvendor;
Bool	matched = False;

	if(!config.server_vendor) {
		delete("Parameter XT_SERVER_VENDOR not set.");
		return;
	}

	sv = XCALL;
	if(!sv) {
		report("%s() returned NULL", TestName);
		FAIL;
	}

	Pvendor = (char *)malloc(strlen(config.server_vendor) * sizeof(char));
	if (Pvendor == (char *)NULL) {
		delete("Could not allocate memory for server vendor string");
		return;
	} else
		CHECK;

	strcpy(Pvendor, config.server_vendor);
	while ((tok = strsep(&Pvendor, SEPS)) != NULL)
		if(strcmp(tok, sv) == 0) {
			matched = True;
			break;
		}

	if(matched == False) {
		report("WARNING: %s() returns unknown value for server vendor string", 
						TestName);
		report("Expected value is one of \"%s\"", config.server_vendor);
		report("Observed value \"%s\"", sv);
		FIP;
		return;
	} else
		CHECK;

	CHECKPASS(2);
