/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: gcntxtfrmg.m,v 1.5 92/06/11 16:16:23 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   GContext
 *   XGContextFromGC(gc)
 *   GC gc;
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XGContextFromGC	1
char    *TestName = "XGContextFromGC";

/*
 * Defines for different argument types
 */
#define A_GC gc


/*
 * Arguments to the XGContextFromGC function
 */
static GC gc;


int 	tet_thistest;

/*
 * Called at the beginning of each test purpose to reset the
 * arguments to their initial values
 */
static void
setargs()
{
	gc = 0;
}

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
	gc = ErrdefGC;
}

/*
 * Assertion XGContextFromGC-1.(A)
 * A call to XGContextFromGC returns the GContext resource ID
 * for the gc argument.
 */
static void
t001()
{
XFontStruct *fontstruct;
GContext gcontext;
int 	pass = 0, fail = 0;

	tpstartup();
	setargs();

	gc = makegc(Dsp, DRW(Dsp));
	gcontext = XGContextFromGC(gc);	
	fontstruct = XQueryFont(Dsp, gcontext);
	
	if(fontstruct->fid != gcontext) {
		report("A call to XGContextFromGC returned a value which when passed to XQueryFont");
		report("did not return a correct GContext ID in fid field of XFontStruct");
		FAIL;
	} else
		PASS;


	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
