/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: txtwdth.m,v 1.7 92/06/11 17:09:45 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   int
 *   XTextWidth(font_struct, string, count)
 *   XFontStruct	*font_struct;
 *   char	*string;
 *   int 	count;
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XTextWidth	1
char    *TestName = "XTextWidth";

/*
 * Defines for different argument types
 */


/*
 * Arguments to the XTextWidth function
 */
static XFontStruct	*font_struct;
static char	*string;
static int 	count;


static int 	ValueReturn;

int 	tet_thistest;

/*
 * Called at the beginning of each test purpose to reset the
 * arguments to their initial values
 */
static void
setargs()
{
	font_struct = 0;
	string = 0;
	count = 0;
}

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XTextWidth-1.(A)
 * A call to XTextWidth returns the sum of the character-width
 * metrics of all characters in the 8-bit character string,
 * string, as rendered in the font referenced by font_struct.
 */
static void
t001()
{
extern	struct	fontinfo	fontinfo[];
extern	int 	nfontinfo;
int 	i;
int 	width;
int 	calcwidth;
char	buf[256];
int 	pass = 0, fail = 0;

	tpstartup();
	setargs();

	for (i = 0; i < 256; i++)
		buf[i] = i;
	string = buf;
	count  = 256;

	for (i = 0; i < nfontinfo; i++) {
		font_struct = fontinfo[i].fontstruct;

		startcall(Dsp);
		if (isdeleted())
			return;
		width = XTextWidth(font_struct, string, count);
		endcall(Dsp);
		if (geterr() != Success) {
			report("Got %s, Expecting Success", errorname(geterr()));
			FAIL;
		}

		calcwidth = txtwidth(font_struct, (unsigned char *)string, count);

		if (width != calcwidth) {
			report("Font %s - width was %d, expecting %d", fontinfo[i].name,
				width, calcwidth);
			FAIL;
		} else
			CHECK;
	}
	CHECKPASS(nfontinfo);
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
