/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: atrptoff.m,v 1.4 92/06/11 17:11:11 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   void
 *   XAutoRepeatOff(display)
 *   Display	*display;
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XAutoRepeatOff	1
char    *TestName = "XAutoRepeatOff";

/*
 * Defines for different argument types
 */
#define A_DISPLAY display


/*
 * Arguments to the XAutoRepeatOff function
 */
static Display	*display;


int 	tet_thistest;

/*
 * Called at the beginning of each test purpose to reset the
 * arguments to their initial values
 */
static void
setargs()
{
	display = Dsp;
}

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XAutoRepeatOff-1.(A)
 * A call to XAutoRepeatOff turns off auto-repeat for the
 * keyboard on the specified display.
 */
static void
t001()
{
XKeyboardState	old, new;
XKeyboardControl	ctr;
int 	pass = 0, fail = 0;

	tpstartup();
	setargs();

	/*
	 * This is just a touch test really.
	 */
	XGetKeyboardControl(display, &old);

	startcall(display);
	if (isdeleted())
		return;
	XAutoRepeatOff(display);
	endcall(display);
	if (geterr() != Success) {
		report("Got %s, Expecting Success", errorname(geterr()));
		FAIL;
	}

	XGetKeyboardControl(display, &new);
	if (new.global_auto_repeat == AutoRepeatModeOff)
		CHECK;
	else {
		report("Auto-repeat was not turned off");
		FAIL;
	}

	ctr.auto_repeat_mode = old.global_auto_repeat;

	XChangeKeyboardControl(display, KBAutoRepeatMode, &ctr);

	CHECKPASS(1);
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
