/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: grphcsexps.m,v 1.9 92/06/11 17:21:31 rws Exp $
 * 
 */
/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_GraphicsExpose	1
char    *TestName = "GraphicsExpose";



#define	EVENT		GraphicsExpose

int 	tet_thistest;

/*
 * Assertion GraphicsExpose-1.(A)
 * When GraphicsExpose events are generated, then they are
 * contiguously delivered by the server.
 */
static void
t001()
{
Display	*display = Dsp;
int	i;
int	expected;
int	lastcount;
Window  w1, w2;
XVisualInfo *vp;
GC	gc;
int	numevents;
unsigned int	width;
int 	pass = 0, fail = 0;

	tpstartup();

/* Create a pair of windows. */
	resetvinf(VI_WIN);
	nextvinf(&vp);
		
	winpair(display, vp, &w1, &w2);
	getsize(display, w1, &width, (unsigned int *) NULL);
/* Create a gc with graphics-exposures flag set to True. */
	gc = makegc(display, w2);
	XSetGraphicsExposures(display, gc, True);
	XSelectInput(display, w1, NoEventMask);	/* is this necessary?...pc */
	XSelectInput(display, w2, NoEventMask);
/* Generate GraphicsExpose events. */
	XSync(display, True);
	XCopyPlane(display, w1, w2, gc, 50, 0, width, 40, 0, 5, 1);
	XSync(display, False);

/* Verify that events were generated. */
	numevents = XPending(display);
	if (numevents == 0) {
		delete("No events delivered");
		return;
	}
	else
		CHECK;
/* Verify that events were delivered contiguously. */
	expected = -1;
	for (i=0; i<numevents; i++) {
		XEvent	event_return;

		if (i == 0)
			CHECK;
		XNextEvent(display, &event_return);
		if (event_return.type != EVENT) {
			report("Received %s event while only expecting %s types",
				eventname(event_return.type), eventname(EVENT));
			delete("Unexpected event received.");
			return;
		}
		lastcount = event_return.xexpose.count;
		if (expected == -1) {
			expected = lastcount;
		}
		else {
			if (lastcount > expected) {
				report("Count (%d) greater than expected (%d)",
					lastcount, expected);
				FAIL;
				break;
			}
			else if (lastcount < expected)
				expected--;
		}
	}
	if (lastcount != 0) {
		report("Last %s had count set to %d, not zero",
			eventname(EVENT), lastcount);
		FAIL;
	}
	else
		CHECK;

	CHECKPASS(3);
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
