/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: allcicnsz.m,v 1.4 92/06/11 17:27:00 rws Exp $
 * 
 */
/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XAllocIconSize	1
char    *TestName = "XAllocIconSize";



int 	tet_thistest;

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XAllocIconSize-1.(A)
 * A call to XAllocIconSize allocates and returns a pointer to
 * a XIconSize structure in which each component is set to
 * zero.
 */
static void
t001()
{
XIconSize	*isize;
int 	pass = 0, fail = 0;

	tpstartup();

	startcall(Dsp);
	if (isdeleted())
		return;
	isize = XAllocIconSize();
	endcall(Dsp);
	if (geterr() != Success) {
		report("Got %s, Expecting Success", errorname(geterr()));
		FAIL;
	}

	if(isize == (XIconSize *) NULL) {
		delete("%s() returned NULL.", TestName);
		return;
	} else
		CHECK;

	if(isize->min_width != 0) {
		report("The min_width component of the XIconSize structure was %d instead of zero", isize->min_width);
		FAIL;
	} else
		CHECK;

	if(isize->min_height != 0) {
		report("The min_height component of the XIconSize structure was %d instead of zero", isize->min_height);
		FAIL;
	} else
		CHECK;

	if(isize-> max_width != 0) {
		report("The max_width component of the XIconSize structure was %d instead of zero", isize-> max_width);
		FAIL;
	} else
		CHECK;

	if(isize->max_height != 0) {
		report("The max_height component of the XIconSize structure was %d instead of zero", isize->max_height);
		FAIL;
	} else
		CHECK;

	if(isize->width_inc != 0) {
		report("The width_inc component of the XIconSize structure was %d instead of zero", isize->width_inc);
		FAIL;
	} else
		CHECK;

	if(isize-> height_inc != 0) {
		report("The height_inc component of the XIconSize structure was %d instead of zero", isize->height_inc);
		FAIL;
	} else
		CHECK;

	CHECKPASS(7);

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion XAllocIconSize-2.(B)
 *   Reason: There is no known portable test method for this assertion
 * When insufficient memory is available, then a call to
 * XAllocIconSize returns NULL.
 */
static void
t002()
{
	report("There is no known portable test method for this assertion");
	UNTESTED;
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	t002, 2,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
