/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: sbtrctrgn.m,v 1.7 92/06/11 17:42:44 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   
 *   XSubtractRegion(sra, srb, dr_return)
 *   Region	sra;
 *   Region	srb;
 *   Region	dr_return;
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XSubtractRegion	1
char    *TestName = "XSubtractRegion";

/*
 * Defines for different argument types
 */


/*
 * Arguments to the XSubtractRegion function
 */
static Region	sra;
static Region	srb;
static Region	dr_return;


int 	tet_thistest;

/*
 * Called at the beginning of each test purpose to reset the
 * arguments to their initial values
 */
static void
setargs()
{
	sra = 0;
	srb = 0;
	dr_return = 0;
}

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XSubtractRegion-1.(A)
 * A call to XSubtractRegion subtracts the region srb from
 * region sra and stores the result in region dr_return.
 */
static void
t001()
{
Region			R1;
Region			R2;
Region			Rres;
static XRectangle	rect = { -43, -54, 122, 23};
static XRectangle	rect2 = { -44, -55, 123, 24};
int 	pass = 0, fail = 0;

	tpstartup();
	setargs();

	R1 = makeregion();
	R2 = makeregion();
	Rres = makeregion();

	if(isdeleted()) return;

	XUnionRectWithRegion(&rect, R1, R1);
	XUnionRectWithRegion(&rect2, R2, R2);
	
	sra = R1;
	srb = R2;
	dr_return = Rres;
	startcall(Dsp);
	if (isdeleted())
		return;
	XSubtractRegion(sra, srb, dr_return);
	endcall(Dsp);
	if (geterr() != Success) {
		report("Got %s, Expecting Success", errorname(geterr()));
		FAIL;
	}

	if(XEmptyRegion(Rres) != True) {
		report("%s() did not return the empty region.", TestName);
		FAIL;
	} else
		CHECK;

	sra = R2;
	srb = R1;
	dr_return = Rres;
	startcall(Dsp);
	if (isdeleted())
		return;
	XSubtractRegion(sra, srb, dr_return);
	endcall(Dsp);
	if (geterr() != Success) {
		report("Got %s, Expecting Success", errorname(geterr()));
		FAIL;
	}

	if(XEmptyRegion(Rres) == True) {
		report("%s() returned the empty region.", TestName);
		FAIL;
	} else
		CHECK;

	XXorRegion(R1,Rres, Rres);
	if(XEqualRegion(Rres,R2) == False) {
		report("%s() did not return expected region.", TestName);
		FAIL;
	} else
		CHECK;

	CHECKPASS(3);
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
