/*
 *      SCCS:  @(#)  kysymdf.m Rel 1.13	    (7/17/92)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1991 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 * 
 */
/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_keysymdef	1
char    *TestName = "keysymdef";



int 	tet_thistest;

/*
 * Assertion keysymdef-1.(A)
 * When the header file <X11/keysymdef.h> is included while
 * the feature test macro XK_LATIN1 is defined, then the
 * symbols in the table which have code 1 are defined to have
 * the hexadecimal values given in the table.
 */
static void
t001()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf1();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysymdef-2.(A)
 * When the header file <X11/keysymdef.h> is included while
 * the feature test macro XK_LATIN2 is defined, then the
 * symbols in the table which have code 2 are defined to have
 * the hexadecimal values given in the table.
 */
static void
t002()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf2();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysymdef-3.(A)
 * When the header file <X11/keysymdef.h> is included while
 * the feature test macro XK_LATIN3 is defined, then the
 * symbols in the table which have code 3 are defined to have
 * the hexadecimal values given in the table.
 */
static void
t003()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf3();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysymdef-4.(A)
 * When the header file <X11/keysymdef.h> is included while
 * the feature test macro XK_LATIN4 is defined, then the
 * symbols in the table which have code 4 are defined to have
 * the hexadecimal values given in the table.
 */
static void
t004()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf4();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysymdef-5.(A)
 * When the header file <X11/keysymdef.h> is included while
 * the feature test macro XK_ARABIC is defined, then the
 * symbols in the table which have code A are defined to have
 * the hexadecimal values given in the table.
 */
static void
t005()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf5();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysymdef-6.(A)
 * When the header file <X11/keysymdef.h> is included while
 * the feature test macro XK_CYRILLIC is defined, then the
 * symbols in the table which have code C are defined to have
 * the hexadecimal values given in the table.
 */
static void
t006()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf6();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysymdef-7.(A)
 * When the header file <X11/keysymdef.h> is included while
 * the feature test macro XK_GREEK is defined, then the symbols
 * in the table which have code G are defined to have the
 * hexadecimal values given in the table.
 */
static void
t007()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf7();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysymdef-8.(A)
 * When the header file <X11/keysymdef.h> is included while
 * the feature test macro XK_HEBREW is defined, then the
 * symbols in the table which have code H are defined to have
 * the hexadecimal values given in the table.
 */
static void
t008()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf8();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysymdef-9.(A)
 * When the header file <X11/keysymdef.h> is included while
 * the feature test macro XK_KATAKANA is defined, then the
 * symbols in the table which have code K are defined to have
 * the hexadecimal values given in the table.
 */
static void
t009()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf9();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysymdef-10.(A)
 * When the header file <X11/keysymdef.h> is included while
 * the feature test macro XK_APL is defined, then the symbols
 * in the table which have code L are defined to have the
 * hexadecimal values given in the table.
 */
static void
t010()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf10();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysymdef-11.(A)
 * When the header file <X11/keysymdef.h> is included while
 * the feature test macro XK_MISCELLANY is defined, then the
 * symbols in the table which have code M are defined to have
 * the hexadecimal values given in the table.
 */
static void
t011()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf11();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysymdef-12.(A)
 * When the header file <X11/keysymdef.h> is included while
 * the feature test macro XK_PUBLISHING is defined, then the
 * symbols in the table which have code P are defined to have
 * the hexadecimal values given in the table.
 */
static void
t012()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf12();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysymdef-13.(A)
 * When the header file <X11/keysymdef.h> is included while
 * the feature test macro XK_SPECIAL is defined, then the
 * symbols in the table which have code S are defined to have
 * the hexadecimal values given in the table.
 */
static void
t013()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf13();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysymdef-14.(A)
 * When the header file <X11/keysymdef.h> is included while
 * the feature test macro XK_TECHNICAL is defined, then the
 * symbols in the table which have code T are defined to have
 * the hexadecimal values given in the table.
 */
static void
t014()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf14();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysymdef-15.(A)
 * When the header file <X11/keysymdef.h> is included, then
 * the symbols in the table are defined to have the hexadecimal
 * values given in the table.
 */
static void
t015()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymdf0();
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	t002, 2,
	t003, 3,
	t004, 4,
	t005, 5,
	t006, 6,
	t007, 7,
	t008, 8,
	t009, 9,
	t010, 10,
	t011, 11,
	t012, 12,
	t013, 13,
	t014, 14,
	t015, 15,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
